package server;

/**
 * <p>Title: äü Ѵ</p>
 * <p> : See JBuilder Configuration</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import java.net.*;
import java.io.*;
import java.util.*;
import util.Clock;
import network.*;
import java.util.*;

/**
 *  νϽ  Ŭ
 * */
public class Server extends NetworkStarter implements ServerInterface
{
  private short m_maxRoom = 99; //ִ äù 
  private int m_serverPort = 40000; //TCP Ʈ

  private NetworkInterface m_starter = null; //Ʈp  ̽
  private UserInterface m_rooms = null; //äù  ̽
  private ServerInterface m_serverService = null; //  Լ ̽


  /**
   *  νϽ Ѵ
   * */
  public Server()
  {
    try
    {
      //Ʈ 
      m_serverPort = Integer.parseInt(System.getProperty("tcp_port"));
    }
    catch(Exception e)
    {
      System.out.println("Server Port Error !");
    }

    //service interface ʱȭ
    m_starter = (NetworkStarter)this;
    m_serverService = (ServerInterface)this;

    //Ŭ̾Ʈ   
    m_rooms = new UserContainer(m_maxRoom);
    if (!createStandbyRoom()) //äô 
    {
      System.out.println("Standby Chatting Room fail !");
      System.exit(-1);
    }

    // Ʈp 
    byte startupRet = m_starter.startNwService(m_serverPort);

    System.out.println("Server Startup Result >> "+startupRet);
    if (startupRet != NetworkStarter.START_OK) System.exit(-1); //۰ ˻

    // ۰ ǥ
    System.out.println("########## CHATTING SERVER STARTUP OK ##########");

    //
    //System.out.println("Server Shutdown Result >> "+this.m_starter.stopNwService());
  }

  /**
   * äô 
   *
   * @return boolean 
   * */
  private final boolean createStandbyRoom()
  {
    // ̵ 
    Integer nRoomId = new Integer(ProtocolInterface.STANDBY_ROOM);
    // 
    ChatRoom standbyRoom = new ChatRoom(
                                       ProtocolInterface.STANDBY_ROOM_TITLE,
                                       nRoomId.byteValue(),
                                       ProtocolInterface.MAX_STANDBY_ROOM_USER,
                                       ""
                                       );
    // 
    return m_rooms.addClient(nRoomId, standbyRoom);
  }

  /**
   * Ŭ̾Ʈ ó
   * */
  public void run()
  {
    try
    {
      while(m_isAlive)
      {
        try
        {
          if (m_serverSoc == null) break;
          m_soc = m_serverSoc.accept();

          //Ŭ̾Ʈ Object 
          Unit unit = new Unit(m_soc, (NetworkInterface)m_starter
                        , (UserInterface)m_rooms
                        , (ServerInterface)m_serverService);

          //Ŭ̾Ʈ Ʈ غ
          if (unit.startService() != false)
              m_starter.receiveFrame(unit); //غ ˻
        }
        catch(Exception ioe)
        {
          System.out.println("Server.run().ioe ="+ioe.toString());
        }
      }
    }
    catch(Exception e)
    {
      System.out.println("Server.run().e ="+e.toString());
    }

    System.out.println("SYSTEM DOWNED !!!");

    m_starter.stopNwService(); // ƮpƮ 
  }

  /**
   * Client Read Stream ó
   *
   * @return Object Ŭ̾Ʈ ü
   *
   * (!)  Ŭ̾Ʈ  ü  ʴ´
   * */
  public Object processReadRequest(Object request)
  {
    Unit unit = (Unit)request;
    unit.receive(); //read client request

    return unit;
  }

  /**
   * Client Read Streamó ۿ ִ ۾ óѴ
   * Read Stream 
   *
   * @param buff ó
   * @return boolean Լȣ
   *
   * (!)  ۿ  ʹ ó ʰ, Ŭ̾Ʈ   
   * */
  public boolean procExtraReadJobToFinishing(ArrayList buff)
  {
    System.out.println("NetworkTest.procExtraReadJobToFinishing().extra job size="+buff.size());
    return true;
  }

  /**
   * Client Write Stream ó
   *
   * @param request Ŭ̾Ʈ ۰ü
   * @return Object Ŭ̾Ʈ ۰ü
   *
   * (!)  ϵǴ Ŭ̾Ʈ ۰ü  ʴ´
   * */
  public Object processWriteRequest(Object request)
  {
    if (request != null)
    {
      UnitSender unit = (UnitSender)request;
      unit.send(); //send result to clent
    }

    return null;
  }

  /**
   * Client Write Streamó ۿ ִ ۾ ó
   * Write Stream 
   *
   * @param buff ó
   * @return boolean Լȣ
   *
   * (!)  ۿ  ʹ ó ʰ, Ŭ̾Ʈ   
   * */
  public boolean procExtraWriteJobToFinishing(ArrayList buff)
  {
    System.out.println("NetworkTest.procExtraWriteJobToFinishing().extra job size="+buff.size());
    return true;
  }

  /**
   * äù ̽ 
   *
   * @return UserInterface
   * */
  public UserInterface getRooms()
  {
    return m_rooms;
  }

  /**
   *  <p>ä  Ѵ</p>
   * */
  public static void main(String[] args)
  {
    //ý  Ķ 
    System.setProperty("reader.thread.min", "1"); //Ŭ̾Ʈ Ʈ б⸦ óϴ ּ  
    System.setProperty("reader.thread.max", "2"); //Ŭ̾Ʈ Ʈ б⸦ óϴ ִ  
    System.setProperty("writer.thread.min", "1"); //Ŭ̾Ʈ Ʈ  óϴ ּ  
    System.setProperty("writer.thread.max", "2"); //Ŭ̾Ʈ Ʈ  óϴ ִ  
    System.setProperty("tcp_port", "20000"); //äü TCP  Ʈȣ

    //
    Server server = new Server();
  }

}